clear
clear matrix
set memory 8m


use ".../DAT_051009.dta", clear

drop if T_CJ_TOTAL>0 & T_JC_TOTAL>0
drop g_Y

gen L_wage_85=log(wage_85)
gen L_wage_84=log(wage_84)
gen L_wage_79=log(wage_79)

gen TR=T_CJ_TOTAL+T_CV_TOTAL+T_JC_TOTAL+T_JV_TOTAL+T_VJ_TOTAL+T_VC_TOTAL
* drop those with more than one transfer
drop if TR>1 
drop if T_VC_TOTAL==1
drop if T_VJ_TOTAL==1

/* Here is where Table 1 and Table 2 are computed
It requires computation of shares */

* next is the regression used in Version A of Table 13
regress L_wage_85 men black RANK SOCIO_LOW SOCIO_MED Father_LHS Father_HS Father_DR LOCHS_* D_V_TOTAL D_C_TOTAL D_J_TOTAL GRAD_V_TOTAL GRAD_C_TOTAL GRAD_J_TOTAL

* merging vocational school with work
replace OUT_72=OUT_72+V_72
replace OUT_73=OUT_73+V_73
replace OUT_74=OUT_74+V_74
replace OUT_75=OUT_75+V_75
replace OUT_76=OUT_76+V_76
replace OUT_77=OUT_77+V_77
replace OUT_78=OUT_78+V_78
replace OUT_79=OUT_79+V_79

replace D_C_72=1 if T_CV_72==1
replace D_C_73=1 if T_CV_73==1
replace D_C_74=1 if T_CV_74==1
replace D_C_75=1 if T_CV_75==1
replace D_C_76=1 if T_CV_76==1
replace D_C_77=1 if T_CV_77==1
replace D_C_78=1 if T_CV_78==1
replace D_C_TOTAL=D_C_72+D_C_73+D_C_74+D_C_75+D_C_76+D_C_77+D_C_78


replace D_J_72=1 if T_JV_72==1
replace D_J_73=1 if T_JV_73==1
replace D_J_74=1 if T_JV_74==1
replace D_J_75=1 if T_JV_75==1
replace D_J_76=1 if T_JV_76==1
replace D_J_77=1 if T_JV_77==1
replace D_J_78=1 if T_JV_78==1
replace D_J_TOTAL=D_J_72+D_J_73+D_J_74+D_J_75+D_J_76+D_J_77+D_J_78

*wage regressions -used in Table 13-
regress L_wage_85 men black RANK SOCIO_LOW SOCIO_MED Father_LHS Father_HS Father_DR LOCHS_* D_C_TOTAL D_J_TOTAL GRAD_C_TOTAL GRAD_J_TOTAL
predict XX, xb
gen resid=L_wage_85-XX
gen WAGE=GRAD_C_TOTAL*_b[GRAD_C_TOTAL]+GRAD_J_TOTAL*_b[GRAD_J_TOTAL]+L_wage_85-XX if GRAD_C_TOTAL==1
replace WAGE=GRAD_C_TOTAL*_b[GRAD_C_TOTAL]+GRAD_J_TOTAL*_b[GRAD_J_TOTAL]+L_wage_85-XX if GRAD_J_TOTAL==1 & T_JC_TOTAL==0
gen wage_C=0
gen wage_J=0
replace wage_C=GRAD_C_TOTAL*_b[GRAD_C_TOTAL]+resid if C_72==1 & GRAD_C_TOTAL==1
replace wage_C=0.03857 if wage_C==.
replace wage_J=GRAD_J_TOTAL*_b[GRAD_J_TOTAL]+resid if J_72==1 & GRAD_J_TOTAL==1 & T_JC_TOTAL==0

regress L_wage_85 men black RANK SOCIO_LOW SOCIO_MED Father_LHS Father_HS Father_DR LOCHS_* GRAD_C_TOTAL GRAD_J_TOTAL

gen O_PROB=0
replace O_PROB=1 if V_72==1
replace O_PROB=2 if J_72==1
replace O_PROB=3 if C_72==1

gen COLLEGE=0
replace COLLEGE=1 if T_CJ_TOTAL==1 & C_72==1
replace COLLEGE=2 if GRAD_C_TOTAL==1 & C_72==1

gen J_COLLEGE=0
replace J_COLLEGE=1 if GRAD_J_TOTAL==1 & J_72==1
replace J_COLLEGE=2 if T_JC_TOTAL==1 & J_72==1

* ordered probit regressions used in Table 11 and Table 12

oprobit O_PROB men black RANK SOCIO_LOW SOCIO_MED SOCIO_HIGH Father_LHS Father_HS Father_C
predict prior, xb

replace O_PROB=0 if V_72==1
oprobit O_PROB men black RANK SOCIO_LOW SOCIO_MED SOCIO_HIGH Father_LHS Father_HS Father_C
predict prior1, xb
