% code for computing the value of information
clear all
close all
clc

gamma=8;
r=0.0045;

a_A=0.1152;
a_C=0.3205;

w_hat_A_1=1.08;
w_hat_A_0=1.03;
w_hat_C_1=1.22;
w_hat_C_0=1.04;

q_F_1_C=0.01;
q_F_0_C=0.2275;
q_E_1_C=0.18;
q_E_0_C=0;%0.001;
q_P_1_C=1-q_F_1_C-q_E_1_C;
q_P_0_C=1-q_F_0_C-q_E_0_C;

q_F_1_A=0;%0.00001;
q_F_0_A=0.23;
q_E_1_A=0.13;
q_E_0_A=0.075;
q_P_1_A=1-q_F_1_A-q_E_1_A;
q_P_0_A=1-q_F_0_A-q_E_0_A;

options = optimset('TolFun',1e-10);
v_1 = w_hat_C_1 ;
for i=1:16
    value_v0(i,1)=fsolve(@(v_0) val_fun(v_0,v_1,a_C,r,gamma,q_E_1_C+q_P_1_C),v_1-0.0002,options);
    v_1 = value_v0(i,1) ;
end

grid_p = [0:0.001:1]';
%Value = grid_p * (-(1+r)/(gamma*r))*exp(-gamma*value_v0(16)) + (1-grid_p )*(-(1+r)/(gamma*r))* exp(-gamma*1) ;

load val_c
val_full = mat_save;
clear mat_save

for i=1:length(grid_p)
   p = grid_p(i) ;
   payoff_info(i,1) = log(exp(-gamma) / (p*exp(-gamma*value_v0(16))+(1-p)*exp(-gamma)))/(gamma*r) ;
end

payoff_noinfo=(val_full-1)/r ; 
price = ((1+r)/r) * 1 ;

ret_info = payoff_info / price ;
ret_noinfo = payoff_noinfo / price ;

figure;
ph=plot(grid_p,ret_info,'b--',grid_p,ret_noinfo,'r')
set(ph,'linewidth',2);
qh=legend('revealed type','baseline')
set(qh,'Fontsize',15)
axis([0 1 0 max(ret_info)])
xlabel('p_0','Fontsize',12)%,'FontWeight','bold')
ylabel('Return','Fontsize',12)%,'FontWeight','bold')



I = 1000;
J=3462;
val_cal = zeros(I,J) ;
for i=1:I
    i
    bel = prior_generator ;
    for j=1:length(bel)
        pp = bel(j) ;
        ubic_aux = find(grid_p>=pp) ;
        ubic = ubic_aux(1) ;
        clear ubic_aux
        val_cal(i,j) = ret_info(ubic)-ret_noinfo(ubic) ;
    end
end
VAL = mean(val_cal);
clear val_cal
