%comparison with risk neutrality 
clear all
close all
clc

%entry thresholds
p_A_gamma_0=0.184;
p_C_gamma_0=0.237;
p_A_gamma_8=0.276;
p_C_gamma_8=0.392;

grid_p=[0:0.001:1];
grid_p=grid_p';
load return_gamma_0
load return_gamma_8

RECORD=zeros(4,2);
K=10000;
for k=1:K
if round(k/100)==k/100
    k
end
PRIOR=prior_generator(1,[0 1]);
A_0=0;
A_8=0;
C_0=0;
C_8=0;
R_A_0=0;
R_A_8=0;
R_C_0=0;
R_C_8=0;
for i=1:length(PRIOR)
    p=PRIOR(i);
    if p==1
        pos=size(grid_p,2);
    elseif p==0
        pos=1;
    else
        aux_pos=find(grid_p>p);
        pos=aux_pos(1)-1;
        clear aux_pos
    end
    if p>p_C_gamma_0
        C_0=C_0+1;
        R_C_0=R_C_0+r_gamma_0(pos);
    elseif p>=p_A_gamma_0 & p<=p_C_gamma_0
        A_0=A_0+1;
        R_A_0=R_A_0+r_gamma_0(pos);
    end
    if p>p_C_gamma_8
        C_8=C_8+1;
        R_C_8=R_C_8+r_gamma_8(pos);
    elseif p>=p_A_gamma_8 & p<=p_C_gamma_8
        A_8=A_8+1;
        R_A_8=R_A_8+r_gamma_8(pos);
    end    
end
RECORD=RECORD+[R_A_0/A_0 R_A_8/A_8;
 R_C_0/C_0 R_C_8/C_8;
 A_0/length(PRIOR) A_8/length(PRIOR);
 C_0/length(PRIOR) C_8/length(PRIOR)];
clear PRIOR A_0 A_8 C_0 C_8 R_A_0 R_A_8 R_C_0 R_C_8
end
RECORD=RECORD/K

figure;
ph=plot(grid_p,r_gamma_0,'b--',grid_p,r_gamma_8,'r')
set(ph,'linewidth',2);
qh=legend('risk neutral','baseline')
set(qh,'Fontsize',15)
axis([0 1 0 max(r_gamma_0)])
line([p_A_gamma_8 p_A_gamma_8],[0 max(r_gamma_8)],'Color','r')
line([p_C_gamma_8 p_C_gamma_8],[0 max(r_gamma_8)],'Color','r')
line([p_A_gamma_0 p_A_gamma_0],[0 max(r_gamma_0)],'Color','b')
line([p_C_gamma_0 p_C_gamma_0],[0 max(r_gamma_0)],'Color','b')
%text('Interpreter','latex','String','$$\;p_d^A(0)$$','Position',[p_C_gamma_8 0.07],'Fontsize',10)
%text('Interpreter','latex','String','$$\;(\gamma = 8)$$','Position',[p_C_gamma_8 0.065],'Fontsize',10)
%text('Interpreter','latex','String','$$\;p_t^A(0)$$','Position',[p_A_gamma_8 0.07],'Fontsize',10)
%text('Interpreter','latex','String','$$\;(\gamma = 8)$$','Position',[p_A_gamma_8 0.065],'Fontsize',10)
xlabel('p_0','Fontsize',12)%,'FontWeight','bold')
ylabel('Return','Fontsize',12)%,'FontWeight','bold')

% figure;
% plot(grid_p,r_gamma_8,'r','LineWidth',2)
% hold on
% plot(grid_p,r_gamma_0,'b--','LineWidth',2)
% axis([0 1 0 max(r_gamma_0)])
% line([p_A_gamma_8 p_A_gamma_8],[0 max(r_gamma_8)],'Color','r')
% line([p_C_gamma_8 p_C_gamma_8],[0 max(r_gamma_8)],'Color','r')
% line([p_A_gamma_0 p_A_gamma_0],[0 max(r_gamma_0)],'Color','b')
% line([p_C_gamma_0 p_C_gamma_0],[0 max(r_gamma_0)],'Color','b')
% text('Interpreter','latex','String','$$\;p_d^A(0)$$','Position',[p_C_gamma_8 0.07],'Fontsize',10)
% text('Interpreter','latex','String','$$\;(\gamma = 8)$$','Position',[p_C_gamma_8 0.065],'Fontsize',10)
% text('Interpreter','latex','String','$$\;p_t^A(0)$$','Position',[p_A_gamma_8 0.07],'Fontsize',10)
% text('Interpreter','latex','String','$$\;(\gamma = 8)$$','Position',[p_A_gamma_8 0.065],'Fontsize',10)
% xlabel('p_0','Fontsize',12)%,'FontWeight','bold')
% ylabel('Return','Fontsize',12)%,'FontWeight','bold')

