clear all
close all
clc

q_F_1_C=0.01;
q_F_0_C=0.2275;
q_E_1_C=0.18;
q_E_0_C=0;
q_P_1_C=1-q_F_1_C-q_E_1_C;
q_P_0_C=1-q_F_0_C-q_E_0_C;

q_F_1_A=0;
q_F_0_A=0.23;
q_E_1_A=0.13;
q_E_0_A=0.075;
q_P_1_A=1-q_F_1_A-q_E_1_A;
q_P_0_A=1-q_F_0_A-q_E_0_A;

PROB_C =[q_F_0_C 1-q_F_0_C-q_E_0_C q_E_0_C;
        q_F_1_C 1-q_F_1_C-q_E_1_C q_E_1_C];
    
PROB_A=[q_F_0_A 1-q_F_0_A-q_E_0_A q_E_0_A;
        q_F_1_A 1-q_F_1_A-q_E_1_A q_E_1_A];

w_hat_A_1=1.08;
w_hat_A_0=1.03;
w_hat_C_1=1.22;
w_hat_C_0=1.04;
        
[thresholds_A,thresholds_C]=general_transfer_credits_v3(PROB_A,PROB_C,w_hat_A_1,w_hat_A_0,w_hat_C_1,w_hat_C_0)

K=10;

T_A=8;
T_C=16;

step=0.001;
grid_p=[0:step:1];
grid_p=grid_p';
N=length(grid_p);

%credits
cred_F=0;
cred_P=1;
cred_E=1;

load moments_1.raw
load moments_2.raw
load moments_3.raw
load moments_4.raw
moments=[moments_1 moments_2 moments_3 moments_4];
clear moments_1 moments_2 moments_3 moments_4

F_D_A=forward_drop_A(thresholds_A,q_F_1_A,q_F_0_A,q_E_1_A,q_E_0_A,q_P_1_A,q_P_0_A,T_A,cred_F,cred_P,cred_E,grid_p,step,N);     
F_T_A=forward_transf_A(thresholds_A,q_F_1_A,q_F_0_A,q_E_1_A,q_E_0_A,q_P_1_A,q_P_0_A,T_A,cred_F,cred_P,cred_E,grid_p,step,N);
F_D_C=forward_drop_C(thresholds_C,q_F_1_C,q_F_0_C,q_E_1_C,q_E_0_C,q_P_1_C,q_P_0_C,T_C,cred_F,cred_P,cred_E,grid_p,step,N);
F_T_C=forward_transf_C(thresholds_C,q_F_1_C,q_F_0_C,q_E_1_C,q_E_0_C,q_P_1_C,q_P_0_C,T_C,cred_F,cred_P,cred_E,grid_p,step,N);

momentum=moments*0;

for j=1:K
    PRIOR=prior_generator(1,[0 1]);
    W=0;
    A=0;
    C=0;
    P_D_A=0;
    P_T_A=0;
    P_D_C=0;
    P_T_C=0;
    for i=1:length(PRIOR)
        p_use=PRIOR(i);
        pp_use=[1 p_use p_use^2 p_use^3];
        if p_use<thresholds_A(1,1)
            W=W+1;
            M_1=1;
            M_2=0;
            M_3=0;
            M_4=0;
            M_5=0;
            M_6=0;
            M_7=0;
            M_8=0;
            M_9=0;
            M_10=0;
            M_11=0;
        elseif p_use>thresholds_A(1,2)
            C=C+1;
            M_1=0;
            M_2=0;
            M_3=1;
            M_4=0;
            M_5=0;
            M_6=0;
            FF_D_C=pp_use*F_D_C;
            if FF_D_C<0
                FF_D_C =0;
            end
            P_D_C=P_D_C+FF_D_C;
            FF_T_C=pp_use*F_T_C;
            if FF_T_C<0
                FF_T_C=0;
            end
            P_T_C=P_T_C+FF_T_C;
            wage_prob_C(C,1)=1-pp_use*F_D_C-pp_use*F_T_C;
            wage_C(C,1)=p_use*w_hat_C_1+(1-p_use)*w_hat_C_0;
            M_7=FF_D_C;
            M_8=FF_T_C;
            M_9=1-M_7-M_8;
            M_10=0;
            M_11=wage_C(C,1);
        else
            A=A+1;
            M_1=0;
            M_2=1;
            M_3=0;
            M_7=0;
            M_8=0;
            M_9=0;
            FF_D_A=pp_use*F_D_A;
            if FF_D_A<0
                FF_D_A=0;
            end
            P_D_A=P_D_A+FF_D_A;
            FF_T_A=pp_use*F_T_A;
            if FF_T_A<0
                FF_T_A=0;
            end
            P_T_A=P_T_A+FF_T_A;
            wage_prob_A(A,1)=1-pp_use*F_D_A-pp_use*F_T_A;
            wage_A(A,1)=p_use*w_hat_A_1+(1-p_use)*w_hat_A_0;
            M_4=FF_D_A;
            M_5=FF_T_A;
            M_6=1-M_4-M_5;
            M_10=wage_A(A,1);
            M_11=0;
        end
        mom(i,:)=[M_1 M_2 M_3 M_4 M_5 M_6 M_7 M_8 M_9 M_10 M_11];
    end
    momentum=momentum+mom;
    if C>0
        ff_g_C=wage_prob_C/sum(wage_prob_C);
        mean_wage_C=ff_g_C'*wage_C;
    else
        mean_wage_C=0;
    end
    if A>0
        ff_g_A=wage_prob_A/sum(wage_prob_A);
        mean_wage_A=ff_g_A'*wage_A;
    else
        mean_wage_A=0;
    end
    FRAC_C=C/length(PRIOR);
    FRAC_A=A/length(PRIOR);
    P_D_C=P_D_C/C;
    P_T_C=P_T_C/C;
    P_D_A=P_D_A/A;
    P_T_A=P_T_A/A;
    P_G_C=1-P_D_C-P_T_C;
    P_G_A=1-P_D_A-P_T_A;
    P_D_C=FRAC_C*P_D_C;
    P_T_C=FRAC_C*P_T_C;
    P_G_C=FRAC_C*P_G_C;
    P_D_A=FRAC_A*P_D_A;
    P_T_A=FRAC_A*P_T_A;
    P_G_A=FRAC_A*P_G_A;
    fraction_C(j,1)=FRAC_C;
    fraction_A(j,1)=FRAC_A;
    prob_t_c(j,1)=P_T_C;
    prob_g_c(j,1)=P_G_C;
    prob_d_c(j,1)=P_D_C;
    prob_t_a(j,1)=P_T_A;
    prob_g_a(j,1)=P_G_A;
    prob_d_a(j,1)=P_D_A;
    wage_A_av(j,1)=mean_wage_A;
    wage_C_av(j,1)=mean_wage_C;
    clear FRAC_C FRAC_A P_T_C P_T_A P_G_C P_G_A P_D_C P_D_A PRIOR W C A wage_A wage_prob_A wage_C wage_prob_C
end
momentum=momentum/K;

moments(:,8)=[];
moments(:,6)=[];
moments(:,3)=[];

momentum(:,8)=[];
momentum(:,6)=[];
momentum(:,3)=[];
%moments
g_data=[0.594;0.152;0.254;0.0957;0.0486;0.0077;0.1041;0.0051;0.1448;0.0445;0.212] ;
g_model=[1-mean(fraction_A)-mean(fraction_C);mean(fraction_A);mean(fraction_C);
         mean(prob_d_a);mean(prob_t_a);mean(prob_g_a);
         mean(prob_d_c);mean(prob_t_c);mean(prob_g_c);
         mean(wage_A_av)-1;mean(wage_C_av)-1] ;
     


gg = [g_data(1) g_model(1)
      g_data(2) g_model(2)   
      g_data(4)/g_data(2) g_model(4)/g_model(2)
      g_data(5)/g_data(2) g_model(5)/g_model(2)
      g_data(7)/g_data(3) g_model(7)/g_model(3)
      g_data(9)/g_data(3) g_model(9)/g_model(3)
      g_data(10) g_model(10)
      g_data(11) g_model(11)] 