%calculates the substitutability of 2-year and 4-year colleges
clear all
close all
clc

load value_only_4year
load return_gamma_8

grid_p=[0:0.001:1];
grid_p=grid_p';

p_A=0.276;
p_C=0.392;
p_E=0.294; %when only 4-year colleges available


MOM=zeros(2,2);
K=100;
for k=1:K
    if round(k/100)==k/100
        k
    end

PRIOR=prior_generator(1,[0 1]);
IN_full=0;
IN_4year=0;
VALUE_full=0;
VALUE_4year=0;
for i=1:length(PRIOR)
    p=PRIOR(i);
    if p==0
        pos=1;
    elseif p==1
        pos=size(grid_p,1);
    else
        aux_p=find(grid_p>p);
        pos=aux_p(1)-1;
        clear aux_p
    end
    if p>=p_E
        IN_4year=IN_4year+1;
        VALUE_4year=VALUE_4year+ret_only_4year(pos);
    end
    if p>=p_A
        IN_full=IN_full+1;
        VALUE_full=VALUE_full+r_gamma_8(pos);
    end
end
MOM=MOM+[VALUE_4year/IN_4year VALUE_full/IN_full;
 IN_4year/length(PRIOR) IN_full/length(PRIOR)]   ;
end
MOM=MOM/K

figure;
ph=plot(grid_p,ret_only_4year,'b--',grid_p,r_gamma_8,'r')
set(ph,'linewidth',2);
qh=legend('only 4-year colleges','baseline')
set(qh,'Fontsize',15)
xlabel('p_0','Fontsize',12)
ylabel('Return','Fontsize',12)


figure;
plot(grid_p,ret_only_4year,'b--','LineWidth',2)
hold on
plot(grid_p,r_gamma_8,'r','LineWidth',2)
axis([0 1 0 max(r_gamma_8)])
xlabel('p_0','Fontsize',12)%,'FontWeight','bold')
ylabel('Return','Fontsize',12)%,'FontWeight','bold')