%compute returns only if 4-year colleges are available (with full options)


%learning parameters
q_F_1_C=0.01;
q_F_0_C=0.2275;
q_E_1_C=0.18;
q_E_0_C=0;%0.001;
q_P_1_C=1-q_F_1_C-q_E_1_C;
q_P_0_C=1-q_F_0_C-q_E_0_C;

q_F_1_A=0;%0.00001;
q_F_0_A=0.23;
q_E_1_A=0.13;
q_E_0_A=0.075;
q_P_1_A=1-q_F_1_A-q_E_1_A;
q_P_0_A=1-q_F_0_A-q_E_0_A;

T_C=16;
T_A=8;
% 
a_A=0.1152;
a_C=0.3205;
% 
gamma=8;
r=0.0045;
% 
w_hat_A_1=1.08;
w_hat_A_0=1.03;
w_hat_C_1=1.22;
w_hat_C_0=1.04;

%wage for dropouts
w=1;
w_low_A=1;
w_low_C=1;
% 
%credit transfer
theta_C=0;%1/10;
theta_A=1/2;

%credits
cred_F=0;
cred_P=1;
cred_E=1;
% 
for i=1:T_C+1
    time_C(i)=i;
end
% 
%construction of credit transfer
TRAN_C=time_C*theta_C;
for i=1:T_C+1
    if TRAN_C(i)<=1
        transfer_C_F(i)=1;
        transfer_C_C(i)=1;
        D_C(i)=1; %prob of floor
    else
        C=ceil(TRAN_C(i));
        F=floor(TRAN_C(i));
        if C==F
            D_C(i)=1;
        else
            D_C(i)=TRAN_C(i)-F;
        end
        transfer_C_F(i)=F;
        transfer_C_C(i)=C;
        if transfer_C_C(i)>T_A
            transfer_C_F(i)=T_A;
            transfer_C_C(i)=T_A;
            D_C(i)=1;
        end
    end
    clear C F
end
transfer_C_F(T_C+1)=transfer_C_F(T_C);
transfer_C_C(T_C+1)=transfer_C_C(T_C);

step=0.001;
grid_p=[0:step:1];
grid_p=grid_p';
N=length(grid_p);
% 
MAT_C=0*ones(T_C+1,N);
MATRIX_C=zeros(T_C,N);
k=0;
condi=1;
while condi==1
    k=k+1
    MAT_C_OLD=MAT_C;
    for i=1:N
        p=grid_p(i);
        if p==1
            p_C_E=1;
            p_C_P=1;
            p_C_F=1;
        elseif p==0
            p_C_E=0;
            p_C_P=0;
            p_C_F=0;
        else
            p_C_E=update(p,q_E_0_C,q_E_1_C);
            p_C_P=update(p,q_P_0_C,q_P_1_C);
            p_C_F=update(p,q_F_0_C,q_F_1_C);
        end
        if p_C_E>=1
            ubic_C_E=N;
        elseif p_C_E<=0
            ubic_C_E=1;
        else
            aux_C_E=find(grid_p>p_C_E);
            ubic_C_E=aux_C_E(1)-1;
            clear aux_C_E
        end
        if p_C_P>=1
            ubic_C_P=N;
        elseif p_C_P<=0
            ubic_C_P=1;
        else
            aux_C_P=find(grid_p>p_C_P);
            ubic_C_P=aux_C_P(1)-1;
            clear aux_C_P
        end
        if p_C_F>=1
            ubic_C_F=N;
        elseif p_C_F<=0
            ubic_C_F=1;
        else
            aux_C_F=find(grid_p>p_C_F);
            ubic_C_F=aux_C_F(1)-1;
            clear aux_C_F
        end
        UU_C_E(i)=ubic_C_E;
        UU_C_P(i)=ubic_C_P;
        UU_C_F(i)=ubic_C_F;
        MAT_C(T_C+1,i)=-(1/gamma)*log(p*exp(-gamma*w_hat_C_1)+(1-p)*exp(-gamma*w_hat_C_0));
        CONT_C(1,i)=2;    
    end
    for j=1:T_C
        if (T_C+1-j)+cred_E>=T_C+1
            u_E=T_C+1;
        else
            u_E=(T_C+1-j)+cred_E;
        end
        if (T_C+1-j)+cred_P>=T_C+1
            u_P=T_C+1;
        else
            u_P=(T_C+1-j)+cred_P;
        end
        if (T_C+1-j)+cred_F>=T_C+1
            u_F=T_C+1;
        else
            u_F=(T_C+1-j)+cred_F;
        end
        for i=1:N
            p=grid_p(i);
            ex_CE(i)=min(exp(-gamma*MAT_C(u_E,UU_C_E(i))),exp(-gamma*w_low_C));
            ex_CP(i)=min(exp(-gamma*MAT_C(u_P,UU_C_P(i))),exp(-gamma*w_low_C));
            ex_CF(i)=min(exp(-gamma*MAT_C(u_F,UU_C_F(i))),exp(-gamma*w_low_C));
            v_tilde_C(T_C+1-j,i)=(p*q_E_1_C+(1-p)*q_E_0_C)*ex_CE(i)+(p*q_P_1_C+(1-p)*q_P_0_C)*ex_CP(i)+(p*q_F_1_C+(1-p)*q_F_0_C)*ex_CF(i);
            MAT_C(T_C+1-j,i)=(-(1/gamma)*log(v_tilde_C(T_C+1-j,i))-r*a_C)/(1+r);
            if max(MAT_C(T_C+1-j,i),w_low_C)==w_low_C
                MATRIX_C(T_C+1-j,i)=0;
                MAT_C(T_C+1-j,i)=w_low_C;
            elseif max(MAT_C(T_C+1-j,i),w_low_C)==MAT_C(T_C+1-j,i)
                MATRIX_C(T_C+1-j,i)=2;
                MAT_C(T_C+1-j,i)=MAT_C(T_C+1-j,i);
            end
        end
        clear ex_CE ex_CP ex_CF    
    end
    if norm(MAT_C-MAT_C_OLD)<0.0000001
        condi=0;
    end
end
ret_only_4year=(MAT_C(1,:)-w)/((1+r)*w)';
aux=find(ret_only_4year>0);
p_E=grid_p(aux(1)-1);
% for i=1:T_A
%     extra_MAX=max(MATRIX_A(i,:));
%     extra_MIN=min(MATRIX_A(i,:));
%     if extra_MAX<2
%         p_J_t(i)=1;
%     else
%         extra_MAX_1=find(MATRIX_A(i,:)==2);
%         p_J_t(i)=grid_p(extra_MAX_1(1));
%         clear extra_MAX_1
%     end
%     if extra_MIN>0
%         p_J_d(i)=0;
%     else
%         extra_MIN_1=find(MATRIX_A(i,:)==0);
%         p_J_d(i)=grid_p(extra_MIN_1(length(extra_MIN_1)));
%         clear extra_MIN_1
%     end
%     clear extra_MIN extra_MAX
% end
% 
% for i=1:T_C
%     extra_MAX=max(MATRIX_C(i,:));
%     extra_MIN=min(MATRIX_C(i,:));
%     if extra_MIN>0
%         p_C_d(i)=0;
%     else
%         extra_MIN_1=find(MATRIX_C(i,:)==0);
%         p_C_d(i)=grid_p(extra_MIN_1(length(extra_MIN_1)));
%         clear extra_MIN_1
%     end
%     AS=MATRIX_C(i,2:N)-MATRIX_C(i,1:N-1);
%     AS_1=find(AS==1);
%     if size(AS_1,2)==0
%         p_C_t(i)=0;
%     else
%         extra_MAX_1=find(MATRIX_C(i,:)==2);
%         p_C_t(i)=grid_p(extra_MAX_1(1)-1);
%         clear extra_MAX_1
%     end
%     clear AS AS_1 extra_MIN extra_MAX
% end
% % 
% AS=CONT_A(1,2:N)-CONT_A(1,1:N-1);
% if sum(AS)==0
%     if CONT_A(1,1)==1
%         p_J_t(T_A+1)=1;
%         p_J_d(T_A+1)=0;
%     elseif CONT_J(1,1)==2
%         p_J_t(T_A+1)=0;
%         p_J_d(T_A+1)=0;
%     end
% else
%     aux_AS=find(AS>0);
%     p_J_d(T_A+1)=0;
%     p_J_t(T_A+1)=grid_p(aux_AS(1));
% end
% clear AS aux_AS
% 
% AS=CONT_C(1,2:N)-CONT_C(1,1:N-1);
% if sum(AS)==0
%     if CONT_C(1,1)==1
%         p_C_t(T_C+1)=1;
%         p_C_d(T_C+1)=0;
%     elseif CONT_C(1,1)==2
%         p_C_t(T_C+1)=0;
%         p_C_d(T_C+1)=0;
%     end
% else
%     aux_AS=find(AS>0);
%     p_C_d(T_C+1)=0;
%     p_C_t(T_C+1)=grid_p(aux_AS(1));
% end
% clear AS aux_AS    
% thresholds_A=[p_J_d' p_J_t'];
% thresholds_C=[p_C_d' p_C_t'];
% 
% % figure;
%plot(grid_p,(MAT_C(1,:)-w)/((1+r)*w),'r','LineWidth',2)
% % axis([0 1 0 max((MAT_C(1,:)-w)/((1+r)*w))])
% % line([p_J_d(1) p_J_d(1)],[0 max((MAT_C(1,:)-w)/((1+r)*w))],'Color','k')
% % line([p_J_t(1) p_J_t(1)],[0 max((MAT_C(1,:)-w)/((1+r)*w))],'Color','k')
% % text('Interpreter','latex','String','$$\;p_S$$','Position',[p_J_t(1) 0.07],'Fontsize',14)
% % text('Interpreter','latex','String','$$\;p_E$$','Position',[p_J_d(1) 0.07],'Fontsize',14)
% % xlabel('p_0','Fontsize',12,'FontWeight','bold')
% ylabel('Return','Fontsize',12,'FontWeight','bold')