clear all
close all
clc

w=1;
step=0.001;
grid_p=[0:step:1];
grid_p=grid_p';
N=length(grid_p);

load return_gamma_8
load value_no_transf
ret_no_transf=ret_no_transf';
load value_no_transf_no_drop
ret_no_transf_no_drop=ret_no_transf_no_drop';

p_A=0.276;
p_C=0.392;

aux_A=find(grid_p>p_A);
pos_A=aux_A(1)-1;
aux_C=find(grid_p>p_C);
pos_C=aux_C(1)-1;
clear aux_A aux_C

grid_A=[p_A:step:p_C]';
grid_C=[p_C+step:step:1]';

for i=1:length(grid_A)
    p=grid_A(i);
    aux_p=find(grid_p>p);
    plot_full_A(i,1)=r_gamma_8(aux_p(1)-1);
    plot_no_transf_A(i,1)=ret_no_transf(aux_p(1)-1);
    plot_no_transf_no_drop_A(i,1)=ret_no_transf_no_drop(aux_p(1)-1);
    clear aux_p
end

for i=1:length(grid_C)
    p=grid_C(i);
    aux_p=find(grid_p>p);
    if p<1
        plot_full_C(i,1)=r_gamma_8(aux_p(1)-1);
        plot_no_transf_C(i,1)=ret_no_transf(aux_p(1)-1);
        plot_no_transf_no_drop_C(i,1)=ret_no_transf_no_drop(aux_p(1)-1);
        clear aux_p
    else
        plot_full_C(i,1)=r_gamma_8(N);
        plot_no_transf_C(i,1)=ret_no_transf(N);
        plot_no_transf_no_drop_C(i,1)=ret_no_transf_no_drop(N);
    end
end

plot_full=[zeros(276,1);plot_full_A;plot_full_C];
plot_no_transf=[zeros(276,1);plot_no_transf_A;plot_no_transf_C];
plot_no_transf_no_drop=[zeros(276,1);plot_no_transf_no_drop_A;plot_no_transf_no_drop_C];
grid_O=[0:step:p_A-step];
for i=1:length(grid_O)
    plot_O(i,1)=0;
end

%decomposition of returns
R_NO_A=plot_no_transf_no_drop_A./plot_full_A;
R_D_A=(plot_no_transf_A-plot_no_transf_no_drop_A)./plot_full_A;
R_T_A=(plot_full_A-plot_no_transf_A)./plot_full_A;
R_NO_A(1)=0;
R_NO_A(2)=0;
R_D_A(1)=0;
R_D_A(2)=0;
R_T_A(1)=0;
R_T_A(2)=0;

R_NO_C=plot_no_transf_no_drop_C./plot_full_C;
R_D_C=(plot_no_transf_C-plot_no_transf_no_drop_C)./plot_full_C;
R_T_C=(plot_full_C-plot_no_transf_C)./plot_full_C;

for i=1:length(R_NO_C)
    if R_NO_C(i)>1
        R_NO_C(i)=1;
    end
    if R_T_C(i)<0
        R_T_C(i)=0;
    end
end

RR=R_NO_A';

figure;
ha = shadedplot(grid_C', R_NO_C'*0, R_NO_C', [0.7 1 0.7], 'g');
hold on
hb = shadedplot(grid_C', R_NO_C', R_NO_C'*0+1, [1 0.7 0.7], 'r');
hold on
hc = shadedplot(grid_A', grid_A'*0, grid_A'*0+1, [0.7 0.7 1], 'b');
hold on
hd = shadedplot(grid_A', RR, RR+R_D_A', [1 0.7 0.7], 'r');
hold on
line([p_A p_A],[0 1],'Color','k','LineWidth',2)
line([p_C p_C],[0 1],'Color','k','LineWidth',2)
axis([0 1 0 1])
hf = shadedplot([0.02 0.06], [0.8 0.8], [0.86 0.86], [0.7 0.7 1], 'b');
hold on
hg = shadedplot([0.02 0.06], [0.72 0.72], [0.78 0.78], [1 0.7 0.7], 'r');
hold on
hh = shadedplot([0.02 0.06], [0.64 0.64], [0.7 0.7], [0.7 1 0.7], 'g');
xlabel('prior (p_0)','Fontsize',10)
text(0.07,0.83,'Transfer Option','FontSize',10,'Color','k','VerticalAlignment','middle');
text(0.07,0.75,'Dropout Option','FontSize',10,'Color','k','VerticalAlignment','middle');
text(0.07,0.67,'Enrollment','FontSize',10,'Color','k','VerticalAlignment','middle');
K=10000;
VALUES=zeros(3,2);
for k=1:K
if round(k/100)==k/100
    k
end

PRIOR=prior_generator(1,[0 1]);
A=0;
C=0;
R_full_A=0;
R_no_transf_A=0;
R_no_transf_no_drop_A=0;
R_full_C=0;
R_no_transf_C=0;
R_no_transf_no_drop_C=0;
for i=1:length(PRIOR)
    p=PRIOR(i);
    if p>p_C
        if p==1
            pos=size(grid_C,1);
        elseif p<0.3930
            pos=1;
        else
            aux_pos=find(grid_C>p);
            pos=aux_pos(1)-1;
            clear aux_pos
        end
        C=C+1;
        R_full_C=R_full_C+R_T_C(pos);
        R_no_transf_C=R_no_transf_C+R_D_C(pos);
        R_no_transf_no_drop_C=R_no_transf_no_drop_C+R_NO_C(pos);
    elseif p>=p_A & p<=p_C
        if p==1
            pos=size(grid_A,1);
        else
            aux_pos=find(grid_A>p);
            pos=aux_pos(1)-1;
            clear aux_pos
        end
        A=A+1;
        R_full_A=R_full_A+R_T_A(pos);
        R_no_transf_A=R_no_transf_A+R_D_A(pos);
        R_no_transf_no_drop_A=R_no_transf_no_drop_A+R_NO_A(pos);
    end
end
VALUES=VALUES+[R_full_A/A R_full_C/C;
 R_no_transf_A/A R_no_transf_C/C;
 R_no_transf_no_drop_A/A R_no_transf_no_drop_C/C];
clear PRIOR
end
VALUES=VALUES/K